require 'nokogiri'
require 'open-uri'

class Screencast 
  URL = URI 'https://peepcode.com/screencasts' 
  attr_reader :title, :image, :link

  def self.all 
    i = 0 
    screencasts = []
    count = self.titles.length
    while i < count
      sc = Screencast.new( titles[i], image_urls[i], links[i] ) 
      screencasts << sc
      i += 1
    end 
    screencasts.collect(&:to_json) 
  end 

  def to_json 
    {   
      title: @title,
      image: @image,
      link: @link
    }   
  end 

private 

  def initialize(title, image, link) 
    @title = title
    @image = image
    @link = link
  end 

  def self.doc
    @doc ||= Nokogiri::HTML(open URL)
  end 

  def self.titles
    @titles ||= doc.css('.covers img').collect{|i| i.attributes['src'].value.split("/")[-1].split(".")[0].split("-").collect(&:capitalize).join(' ') }
  end 

  def self.image_urls 
    @image_urls ||= doc.css('.covers img').collect{|i| "https://peepcode.com" + i.attributes['src'] }
  end 

  def self.links
    @links ||= doc.css('.covers a').collect{|a| "https://peepcode.com" + a.attributes['href'] }
  end 
end 
